/// <reference types="node" />
import { BinaryLike } from "crypto";
import { HybridCryptography, SwhsBody, SwhsHeaders } from "./HybridCryptography";
export declare class HandshakeClient extends HybridCryptography {
    private strSessionId;
    private objKeys;
    readonly SessionId: string;
    constructor();
    validateResponseSwhsHeader(headers: SwhsHeaders): void;
    generateHandshake(): {
        headers: SwhsHeaders;
        body: SwhsBody;
    };
    encryptRequest(body: BinaryLike | object): {
        headers: SwhsHeaders;
        body: SwhsBody;
    };
    handleHandshakeResponse(headers: SwhsHeaders, body: SwhsBody): string | Buffer | undefined;
    decryptResponse(headers: SwhsHeaders, body: SwhsBody): string | Buffer | undefined;
}
