/// <reference types="node" />
import { BinaryLike } from "crypto";
import { HybridCryptography, SwhsBody, SwhsHeaders } from "./HybridCryptography";
export { SwhsBody, SwhsHeaders } from "./HybridCryptography";
export interface SwhsDecryption {
    next_prv: string;
    created_date: number;
}
export declare class HandshakeServer extends HybridCryptography {
    constructor();
    handleHandshakeRequest(headers: SwhsHeaders): {
        headers: SwhsHeaders;
        body: SwhsBody;
        decrypt: SwhsDecryption;
    };
    decryptRequest(headers: SwhsHeaders, body: SwhsBody, nextPrv: Buffer, passphrase: string): {
        body: any;
        next_pub: string | Buffer;
    };
    encryptResponse(swhsSessionId: string, body: BinaryLike | object, rsaPub: Buffer | string): {
        headers: SwhsHeaders;
        body: SwhsBody;
        decrypt: SwhsDecryption;
    };
}
